/******************************************************************************
* Filename: Spelldlg.h
* Copyright (c) 2000, UAF Development Team (email CocoaSpud@hotmail.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
******************************************************************************/

/////////////////////////////////////////////////////////////////////////////
// CSpell dialog
#include "items.h"
#include "char.h"
#include "spell.h"
#include "SortableListCtrl.h"

class CSpell : public CDialog
{
// Construction
public:
  // before passing in your spell book, make sure the spell limits and allowed
  // classes are initialized.
  //
  // if MaxSelectable==0 (default) then no limit enforced on how many spells
  // can be selected.
  //
  // after constructing this class, you can change the window title by 
  // adding text to the m_NewTitle member, otherwise the default title
  // is displayed.
  //
	CSpell(spellBookType &books, DWORD MaxSelectable=0, CWnd* pParent = NULL);   // standard constructor
	void GetSpellList(spellBookType &books);
	
// Dialog Data
	//{{AFX_DATA(CSpell)
	enum { IDD = IDD_SPELLS };
	CSortableListCtrl	m_ChosenList;
	CSortableListCtrl	m_AvailList;
	CString	m_CharClassText;
	CString	m_MaxSpells;
	//}}AFX_DATA

  CString m_NewTitle;
  
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSpell)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
  void AddToChosenList(GLOBAL_SPELL_ID spell);
  void AddToAvailList(SPELL_DATA &data);

  spellBookType m_books;
  DWORD m_max;

	// Generated message map functions
	//{{AFX_MSG(CSpell)
	virtual BOOL OnInitDialog();
	afx_msg void OnDblclkAvaillist(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclkChosenlist(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
