/******************************************************************************
* Filename: Traindlg.cpp
* Copyright (c) 2000, UAF Development Team (email CocoaSpud@hotmail.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
******************************************************************************/

#include "..\Shared\stdafx.h"
#include "resource.h"

//#include "UAFWinEd.h"
#include "GlobalData.h"
#include "Char.h"
#include "GameEvent.h"

#include "SelectPicDlg.h"
#include "TrainDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTrainingHall dialog


CTrainingHall::CTrainingHall(TRAININGHALL& halls, CWnd* pParent /*=NULL*/)
	: CDialog(CTrainingHall::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTrainingHall)
	m_ForceExit = FALSE;
	m_Clerics = FALSE;
	m_Druids = FALSE;
	m_Fighters = FALSE;
	m_MagicUsers = FALSE;
	m_Paladins = FALSE;
	m_Rangers = FALSE;
	m_Text = _T("");
	m_Thiefs = FALSE;
	m_Cost = 0;
	m_CoinName = _T("");
	//}}AFX_DATA_INIT

	m_halls = halls;
}


void CTrainingHall::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTrainingHall)
	DDX_Control(pDX, IDC_TRAINER, m_ChooseTrainer);
	DDX_Check(pDX, IDC_FORCEEXIT, m_ForceExit);
	DDX_Check(pDX, IDC_CLERICS, m_Clerics);
	DDX_Check(pDX, IDC_DRUIDS, m_Druids);
	DDX_Check(pDX, IDC_FIGHTERS, m_Fighters);
	DDX_Check(pDX, IDC_MAGICUSERS, m_MagicUsers);
	DDX_Check(pDX, IDC_PALADINS, m_Paladins);
	DDX_Check(pDX, IDC_RANGERS, m_Rangers);
	DDX_Text(pDX, IDC_TEXT, m_Text);
	DDX_Check(pDX, IDC_THIEFS, m_Thiefs);
	DDX_Text(pDX, IDC_TRAINCOST, m_Cost);
	DDX_Text(pDX, IDC_COINNAME, m_CoinName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTrainingHall, CDialog)
	//{{AFX_MSG_MAP(CTrainingHall)
	ON_BN_CLICKED(IDC_TRAINER, OnTrainer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTrainingHall message handlers

void CTrainingHall::OnTrainer() 
{
  CSelectPicDlg dlg(m_halls.pic, SmallPicDib);

  if (dlg.DoModal() == IDOK)
  {
    dlg.GetData(m_halls.pic);
    char name[MAX_MEDITBUTTON_TEXT+1];
    getBaseName(m_halls.pic.filename, name, MAX_MEDITBUTTON_TEXT);
    m_ChooseTrainer.SetWindowText(name);
  }
}


BOOL CTrainingHall::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_ForceExit = m_halls.forceExit;
  m_Clerics = m_halls.TrainCleric;
  m_Druids = m_halls.TrainDruid;
  m_Fighters = m_halls.TrainFighter;
  m_MagicUsers = m_halls.TrainMagicUser;
  m_Paladins = m_halls.TrainPaladin;
  m_Rangers = m_halls.TrainRanger;
  m_Thiefs = m_halls.TrainThief;
  m_Text = m_halls.text;
  m_Cost = m_halls.Cost;

  char name[MAX_MEDITBUTTON_TEXT+1];
  getBaseName(m_halls.pic.filename, name, MAX_MEDITBUTTON_TEXT);
  m_ChooseTrainer.SetWindowText(name);

  GotoDlgCtrl(GetDlgItem(IDC_TEXT));
  m_CoinName = globalData.moneyData.GetName(globalData.moneyData.GetDefaultType());
  UpdateData(FALSE);	
	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTrainingHall::GetHallData(TRAININGHALL& halls) 
{
	halls = m_halls;	
}

void CTrainingHall::OnOK() 
{
	UpdateData(TRUE);

	m_halls.forceExit = m_ForceExit;	
  m_halls.TrainCleric = m_Clerics;
  m_halls.TrainDruid = m_Druids;
  m_halls.TrainFighter = m_Fighters;
  m_halls.TrainMagicUser = m_MagicUsers;
  m_halls.TrainPaladin = m_Paladins;
  m_halls.TrainRanger = m_Rangers;
  m_halls.TrainThief = m_Thiefs;
  m_halls.text = m_Text;
  m_halls.Cost = m_Cost;
	
	CDialog::OnOK();
}
